drage_app/urls.py
from django.contrib import admin
from django.urls import include,path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('projets/',include('projets.urls', namespace='projet')),
    path('planning/',include('planning.urls', namespace='planning')),
    path('',include('home.urls', namespace='home')),
]

home/urls.py
from django.urls import path

from . import views

app_name = 'Home'

urlpatterns = [
    path('', views.home, name='home'),
]

projets/urls.py
from django.urls import path, include
from rest_framework import routers
from . import views

app_name = 'Projets'

router = routers.DefaultRouter()
router.register(r'collaborateurs', views.CollaborateurView, 'collaborateur')
urlpatterns = [
    path('admin/', views.admin, name='admin'),
    path('admin/client/new',views.new_client_admin,name='newClientAdmin'),
    path('admin/user/new',views.new_user_admin,name='newUserAdmin'),
    path('api/',include(router.urls)),
    path('api/projet/',views.ProjetList.as_view()),
    path('api/collaborateur',views.CollaborateurListCreate.as_view()),
    path('actives', views.activeProjectsView,name='active_projects'),
    path('new', views.newProject, name='newProject'),
    path('edit/<int:id_projet>',views.editProject,name='editProjet'),
    path('edit/<int:id_projet>/commandes/new',views.newCommande,name='newCommande'),
    path('edit/<int:id_projet>/commande/<int:id_commande>',views.editCommande,name='editCommande'),
    path('client/new', views.newClient,name='newClient'),
    path('api/projet/<int:id_projet>/plan_charge', views.planCharge, name='planCharge'),
    path('api/accompagnements', views.accompagnements, name='accompagnements'),
    path('archived', views.archivedProjectsView, name='archived_projects'),
    path('edit/<int:id_projet>/cloturer', views.ClotureProjet.as_view(), name='cloturer'),
]

projets/models.py
from django.db import models
from django.apps import apps
from django.apps import apps
from django.contrib.auth.models import User
from django.conf import settings

from planning.models import Intervention

TYPES_MISSIONS = [
    ('1','Forfait'),
    ('2','Mission (planning)'),
    ('3','Frais vendus')
]
# Create your models here.
class Client(models.Model):
    nom = models.CharField(max_length=255)
    def __str__(self):
        return self.nom


class Type_accompagnement(models.Model):
    libelle = models.CharField(max_length=255)
    def __str__(self):
        return self.libelle


class Plan_facturation(models.Model):
    libelle = models.CharField(max_length=255)
    def __str__(self):
        return self.libelle


class Projet(models.Model):
    nom = models.CharField(max_length=255)
    ville=models.CharField(max_length=255)
    departement = models.IntegerField()
    cloture = models.DateField(null=True,blank=True)
    client = models.ForeignKey('Client',on_delete=models.CASCADE)
    accompagnement = models.ForeignKey('Type_accompagnement',on_delete=models.CASCADE)
    plan_facturation = models.ForeignKey('Plan_facturation',on_delete=models.CASCADE)
    km_AR = models.IntegerField(null=True,blank=True)
    peage = models.FloatField(null=True,blank=True)
    nb_AR = models.IntegerField(null=True,blank=True)
    autre = models.FloatField(null=True,blank=True)
    commentaire_frais = models.TextField(null=True,blank=True)
    
    def _str_(self):
        return self.nom
    @property
    def get_year(self):
        return self.cloture.year


class Commande(models.Model):
    libelle = models.CharField(max_length=255)
    projet = models.ForeignKey('Projet',on_delete=models.CASCADE)
    numero = models.IntegerField(default=1)
    def __str__(self):
        return self.libelle


class Collaborateur(models.Model):
    nom = models.CharField(max_length=255)
    prenom = models.CharField(max_length=255)


class Mission(models.Model):
    type_mission = models.CharField(choices=TYPES_MISSIONS, max_length=255, null=True)
    montant = models.IntegerField(null=True,blank=True)
    commande = models.ForeignKey(Commande, on_delete=models.CASCADE)
    collaborateur = models.ForeignKey(settings.AUTH_USER_MODEL,on_delete=models.CASCADE,null=True)
    tjm = models.IntegerField(null=True,blank=True)
    jours_vendus = models.IntegerField(null=True,blank=True)

    @property
    def nom_projet(self) -> str:
        projet = Projet.objects.get(pk=self.commande.projet.id)
        return projet.nom

    @property
    def to_staff(self)-> int:
        """
            Indique le nombre de dj restants a staffer pour la mission
        """
        interventions = Intervention.objects.filter(mission=self).count()
        return (self.jours_vendus - interventions)
    
    @property
    def numero_commande(self)-> int:
        """
        Indique le numero de la commande associee
        """
        return self.commande.numero

projets/forms.py
from django import forms
from django.contrib.auth.models import User
from .models import *
from django.forms import modelformset_factory

class NewProjectForm(forms.ModelForm):
    class Meta:
        model = Projet
        fields = '__all__'
        exclude =  ('cloture',)
        help_texts = {'client': '<a href="/projets/client/new">Nouveau client ?</a>'} 


class ProjectForm(forms.ModelForm):
    class Meta:
        model = Projet
        fields = '__all__'
        widgets= {
            'cloture': forms.DateInput(attrs={'type':'date'})
        }


class ClotureProjetForm(forms.ModelForm):
    class Meta:
        model = Projet
        fields = ['cloture']
        widgets= {
            'cloture': forms.DateInput(attrs={'type':'date'})
        }
class NewCommandeForm(forms.ModelForm):
    class Meta:
        model = Commande
        fields = '__all__'
        exclude = ['projet','numero']

MissionModelFormset = modelformset_factory(
    Mission,
    fields = '__all__',
    widgets={
            'commande': forms.HiddenInput()
        },
    extra=1,
    can_delete=True
)
class NewClientForm(forms.ModelForm):
    class Meta:
        model = Client
        fields = '__all__'
class NewUserForm(forms.ModelForm):
    class Meta:
        model = User
        fields = ['username','password','email','first_name','last_name']

projets/views.py
import ast

from django.shortcuts import render, redirect
from django.http import HttpResponse
from django.contrib.auth.hashers import make_password
from django.contrib.auth.models import User
from django.views.generic import UpdateView
from rest_framework import viewsets
from rest_framework.views import APIView
from rest_framework import generics
from rest_framework.response import Response
from rest_framework.decorators import api_view
from rest_framework.authentication import SessionAuthentication, BasicAuthentication
from rest_framework.permissions import IsAuthenticated
from .serializers import *
from .forms import *
from .models import *
from django.urls import reverse_lazy
from django.core.exceptions import ValidationError

from planning.models import Intervention
from facturation.models import Facture
from facturation.forms import FactureFormSet

  
class ProjetList(generics.ListAPIView):
    serializer_class = ProjetSerializer
    def get_queryset(self):
        acc = [acc.id for acc in Type_accompagnement.objects.all()]
        query_string = ''
        if self.request.GET.get('acc'):
            acc = ast.literal_eval(self.request.GET.get('acc'))
        if self.request.GET.get('string'):
            query_string = self.request.GET.get('string')
        if self.request.GET.get('cloture') and ast.literal_eval(self.request.GET.get('cloture')):
            projets = Projet.objects.filter(accompagnement__in=acc, nom__icontains=query_string, cloture__isnull=False)
        else:
            projets = Projet.objects.filter(accompagnement__in=acc, nom__icontains=query_string, cloture__isnull=True)
        return projets

class CollaborateurView(viewsets.ModelViewSet):
    serializer_class = CollaborateurSerializer
    queryset = User.objects.all()

class CollaborateurListCreate(generics.ListCreateAPIView):
    serializer_class = CollaborateurSerializer
    queryset = User.objects.all()



@api_view(['GET'])
def planCharge(request, id_projet):
    if request.method == 'GET':
        projet = Projet.objects.get(pk=id_projet)
        missions = Mission.objects.filter(commande__projet=projet)
        # Grouper les missions par id de collaborateur
        # Creer un dictionnaire avec 
        # {
        #    1: [{
        #    'jours_vendus':
        #    'id_mission':
        # }]
        # }
        payload = []
        collaborateurs = {}
        for mission in missions:
            data = {
                'jours_vendus': mission.jours_vendus,
                'tjm': mission.tjm,
                'id_mission': mission.id
            }
            # Groupe toutes les missions d'un collaborateur
            current_key = mission.collaborateur.id
            collaborateurs.setdefault(current_key, []).append(data)
        # Reprend tous les collaborateurs
        # Cree le paquet de donnees associees
        for id_collab in collaborateurs:
            collaborateur = User.objects.get(pk=id_collab)
            payload_collab = {
                'firstName': collaborateur.first_name,
                'lastName': collaborateur.last_name,
                'id': collaborateur.id
            }
            payload_mission = []
            # Calcul du planifie et total global
            total = 0
            planifie = 0
            payload_interventions = []
            # Parcours l'agregat de missions pour creer le paquet de donnees
            for mission in collaborateurs[id_collab]:
                nb_interventions = 0
                # Recupere les interventions, le nombre de jours places et le total / mission
                if mission['jours_vendus'] is not None:
                    interventions = Intervention.objects.filter(mission=mission['id_mission'])
                    # Augmente le total et le planifie global si des jours ont ete vendus
                    total+= mission['jours_vendus']
                    planifie+=len(interventions)
                    for intervention in interventions:
                        payload_interventions.append({
                            'date': intervention.date,
                            'am': intervention.am,
                            'lieu': projet.ville,
                            'projet': projet.nom,
                            'prix': mission['tjm'] * 0.5
                        })
                    # Recupere les interventions
                    
                payload_mission.append({
                    'id_mission': mission['id_mission'],
                    'jours_vendus': mission['jours_vendus'],
                    'planifies': nb_interventions
                })
            payload_interventions.sort(key=lambda x: x['date'])
            payload.append({
                'collaborateur':payload_collab,
                'missions': payload_mission,
                'meta': {
                    'planifie':planifie,
                    'total':total
                },
                'interventions': payload_interventions
            })
        return Response(payload)

@api_view(['GET'])
def accompagnements(request):
    if request.method == 'GET':
        type_acc = Type_accompagnement.objects.all()
        serializer = TypeAccompagnementSerializer(type_acc,  many=True)
        return Response(data=serializer.data)

def admin(request):
    form_new_client = NewClientForm(request.POST or None)
    form_new_user = NewUserForm(request.POST or None)
    return render(request,'admin.html',locals())

def new_client_admin(request):
    form_new_client = NewClientForm(request.POST or None)
    form_new_user = NewUserForm(None)
    if request.method == 'POST':
        form_new_client = NewClientForm(request.POST)
        if form_new_client.is_valid():
            form_new_client.save()
    return render(request,'admin.html',locals())

def new_user_admin(request):
    form_new_client = NewClientForm(None)
    form_new_user = NewUserForm(request.POST or None)
    if form_new_user.is_valid():
        sign_up = form_new_user.save(commit=False)
        sign_up.password = make_password(form_new_user.cleaned_data['password']) 
        sign_up.save()
    return render(request,'admin.html',locals())
def activeProjectsView(request):
    return render(request,'active_projects.html')
def archivedProjectsView(request):
    return render(request, 'archived_projects.html')
def newClient(request):
    form = NewClientForm(request.POST or None)
    if form.is_valid():
        form.save()
    return render(request,'new_client.html',locals())

def newProject(request):
    form = NewProjectForm(request.POST or None)
    if form.is_valid():
        form.save()
    return render(request,'new_project.html',locals())

def editProject(request,id_projet):
    """
    Permet d'afficher la page d'édition d'un projet
    """
    # Récupère le formulaire pour créer une commande
    newCommande = NewCommandeForm()
    # Récupère les données d'un projet et ses commandes
    projet = Projet.objects.get(id=id_projet)
    commandes = Commande.objects.filter(projet=id_projet)
    factures = Facture.objects.filter(projet=projet)
    factures_formset = FactureFormSet(queryset=factures)
    # Récupère les missions associées aux commandes
    commandes_missions = []
    dj_vendues = 0
    dont_hors_site = 0
    ca_vendu = 0
    for commande in commandes:
        montant_ht = 0
        missions = Mission.objects.filter(commande=commande.id)
        # Calcule le montant hors taxe de la commande
        for mission in missions:
            if mission.type_mission == '1' or mission.type_mission == '3':
                montant_ht += mission.montant
                ca_vendu += mission.montant
            elif mission.type_mission == '2':
                montant_ht += mission.jours_vendus * mission.tjm
                ca_vendu += mission.jours_vendus * mission.tjm
                dj_vendues += mission.jours_vendus
        missionsForm = MissionModelFormset(queryset=missions,
        initial=[{'commande':commande.id}])
        commandes_missions.append([commande,missionsForm, montant_ht])

    # Affiche le formulaire pour modifier le projet
    form = ProjectForm(request.POST or None, instance=projet)

    # Mets à jour le projet
    if request.method == 'POST':
        if form.is_valid():
          form.save()
    return render(request,'project.html',locals())

#Editer une commande, ajouter une mission a une commande
def editCommande(request,id_projet,id_commande):
    if request.method == 'POST':
        missionsForm = MissionModelFormset(request.POST)
        if missionsForm.is_valid():
            missionsForm.save()
    return redirect('projet:editProjet',id_projet=id_projet)
        
#Creer une nouvelle commande
def newCommande(request,id_projet):
    if request.method == 'POST':
        form = NewCommandeForm(request.POST or None)
        if form.is_valid():
            newCommande = form.save(commit=False)
            projet = Projet.objects.get(id=id_projet)
            nbCommandes = Commande.objects.filter(projet = id_projet).count()
            newCommande.numero = nbCommandes+1
            newCommande.projet = projet
            newCommande.save()
    return redirect('projet:editProjet',id_projet=id_projet)
# Vue pour cloturer le projet
class ClotureProjet(UpdateView):
    model = Projet
    form_class = ClotureProjetForm
    template_name = 'cloture.html'
    pk_url_kwarg = 'id_projet'

    def form_valid(self, form):
        form.save()
        return redirect('projet:active_projects')

projets/templates/active_projects.html
{% extends 'base.html' %}
{% load render_bundle from webpack_loader %}
{% render_bundle 'main' 'css' %}
{% block content %}
<div class="row">
    <div class="col-6 left-align">
        <h1>Projets actifs</h1>
    </div>
</div>
<div class="row">
    <div class="col-6 left-align">
        <a href="{% url 'projet:newProject' %}" class="btn btn-light mx-3">Nouveau projet</a>
        <a href="{% url 'projet:archived_projects' %}" class="btn btn-light mx-3">Projets archivés</a>
    </div>
</div>
<div id="react-app"></div>
    <!-- Webpack rendered JS -->
    {% render_bundle 'main' 'js' %}
{% endblock %}

projets/templates/admin.html
{% extends 'base.html' %}

{% load crispy_forms_tags %}

{% block content %}
<h1>Ajouter un collaborateur</h1>
{% if envoi %}Le collaborateur a bien été ajouté{% endif %}
<form action="{% url "newUserAdmin" %}" method="post">
    {% csrf_token %}
    {{ form_new_user | crispy }}
    <input class='btn btn-warning' type="submit" value="Submit" />
</form>
<h1>Ajouter un nouveau client</h1>
{% if envoi %}Le client a bien été ajouté{% endif %}
<form action="{% url "newClientAdmin" %}" method="post">
    {% csrf_token %}
    {{ form_new_client | crispy }}
    <input class='btn btn-warning' type="submit" value="Submit" />
</form>
{% endblock %}

projets/templates/archived_projects.html
{% extends 'base.html' %}
{% load render_bundle from webpack_loader %}
{% render_bundle 'main' 'css' %}
{% block content %}
<div class="row">
    <div class="col-6 left-align">
        <h1>Projets archivés</h1>
    </div>
</div>
<div class="row">
    <div class="col-6 left-align">
        <a href="{% url 'projet:active_projects' %}" class="btn btn-light mx-3">Projets actifs</a>
    </div>
</div>
<div id="react-app"></div>
    <!-- Webpack rendered JS -->
    {% render_bundle 'main' 'js' %}
{% endblock %}

projets/templates/cloture.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% load widget_tweaks %}
{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form | crispy }}
    <input class='btn btn-outline-success' type="submit" value="Cloturer">
</form>
{% endblock %}

projets/templates/new_client.html
{% extends 'base.html' %}

{% load crispy_forms_tags %}

{% block content %}
<h1>Ajouter un nouveau client</h1>
{% if envoi %}Votre message a bien été envoyé !{% endif %}
<form action="{% url 'projet:newClient' %}" method="post">
    {% csrf_token %}
    {{ form | crispy }}
    <input class='btn btn-warning' type="submit" value="Submit" />
</form>
{% endblock %}

projets/templates/new_commande.html
<form method="post" action="">
    {% csrf_token %}
  
   <div class="modal-header">
      <h5 class="modal-title">Ajouter une commande</h5>
      <button type="button" class="close" data-dismiss="modal" aria-label="Close">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
  
    <div class="modal-body">
      {% for field in form %}
        <div class="form-group{% if field.errors %} invalid{% endif %}">
          <label for="{{ field.id_for_label }}">{{ field.label }}</label>
          {{ field }}
          {% for error in field.errors %}
            <p class="help-block">{{ error }}</p>
          {% endfor %}
        </div>
      {% endfor %}
    </div>
  
    <div class="modal-footer">
      <button type="button" class="btn btn-default" data-dismiss="modal">Annuler</button>
      <button type="button" class="submit-btn btn btn-primary">Créer la commande</button>
    </div>
  
  </form>

projets/templates/new_project.html
{% extends 'base.html' %}

{% load crispy_forms_tags %}

{% block content %}
<h1>Ajouter un nouveau projet</h1>
{% if envoi %}Votre message a bien été envoyé !{% endif %}
<form action="{% url 'projet:newProject' %}" method="post">
    {% csrf_token %}
    {{ form | crispy }}
    <input class='btn btn-warning' type="submit" value="Submit" />
</form>
{% endblock %}

projets/templates/project.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% load widget_tweaks %}
{% load render_bundle from webpack_loader %}
{% load static %}
{% render_bundle 'main' 'css' %}
{% block content %}
{% if envoi %}Votre message a bien été envoyé !{% endif %}
<h1>Projet</h1>
{% if projet.cloture  ==  None %}
    <a href="{% url 'projet:cloturer' projet.id %}" class='btn btn-light'>Cloturer</a>
{% endif %}
<div class='row mt-5'>
    <div class='col-12 text-center card border-grey border-left-0 border-right-0'>
        <h2>Données du projet</h2>
        <form action="" method="post">
            {% csrf_token %}
            {{ form | crispy }}
            <input class='btn btn-warning' type="submit" value="Editer" />
        </form>
    </div>
</div>
<div class='row mt-5'>
    <div class='col-12 text-center card border-grey border-left-0 border-right-0'>
        <h2>Commandes</h2>
        <div class="row">
            <div class="col-4">&#x25B6; Nombre de DJ vendues : <span class="badge badge-light mx-2">{{dj_vendues}}</span> <small>1/2 journées</small></div>
            <div class="col-4">&#x25B6; Dont DJ hors site : <span class="badge badge-light mx-2">{{dj_vendues}}</span> <small>1/2 journées</small></div>
            <div class="col-4">&#x25B6; CA Vendu : <span class="badge badge-light mx-2">{{ca_vendu}} €</span></div>
        </div>
        
        {% for couple in commandes_missions %}
        <div>
            <div class="row"><h3>Commande n°{{couple.0.numero}} : </h3></div>
            <div class='row'>Montant HT de la commande :  <span class='badge badge-info mx-2'>{{couple.2}} €</span></div> 

            <button class="btn btn-outline-success add-form-row">
                <i class="fas fa-plus-square"></i> 
                Ajouter une mission à la commande n° {{couple.0.numero}}
            </button>
            </br>
            <form class="form-horizontal" method="POST" action="{% url 'projet:editCommande' projet.id couple.0.id %}">
                {% csrf_token %}
                {{ couple.1.management_form }}
                {% for mission in couple.1 %}
                <div class='form-row'>
                    {{mission | crispy}}
                    <button class='btn btn-outline-danger remove-form-row m2'><i class="fas fa-trash"></i></button>
                </div>
                {% endfor %}
                <div class="row spacer">
                    <div class="col-4">
                        <small class='text-muted'>Merci de ne pas laisser de mission vide.</small>
                        <button type="submit" class="btn btn-block btn-outline-primary">
                            <i class="fas fa-save"></i>
                            Enregistrer les missions de la commande n° {{couple.0.numero}}
                        </button>
                    </div>
                </div>
            </form>
        </div>
        {% endfor %}
        <div id="createCommandeDiv">
            <h3>Nouvelle commande</h3>
            <form class="form-horizontal" method="POST" action="{% url 'projet:newCommande' projet.id %}">
                {% csrf_token %}
                {{newCommande | crispy}}
                <button type="submit" class="btn btn-outline-success">Enregistrer la commande</button>
            </form>
            <button id="cancelCreateCommande" class="btn btn-outline-danger">Annuler</button>
        </div>
        </br>
        <button id="createCommandeBtn" class="btn btn-outline-success m-4" type="button">Ajouter une commande</button>
    </div>
</div>

<div class='row my-5'>
    <div class='col-12 text-center card border-grey border-left-0 border-right-0'>
        <h2>Plan de charge</h2>
        <div id="react-app"></div>
        <!-- Webpack rendered JS -->
        {% render_bundle 'main' 'js' %}
    </div>
</div>
<div class='row mt-5'>
    <div class='col-12 text-center card border-grey border-left-0 border-right-0'>
        <h2>Facturation</h2>
        <button id='add-form-facturation' class="btn btn-block btn-outline-success">
            <i class="fas fa-plus-square"></i> 
            Ajouter une facture
        </button>
        <form class='form-horizontal' method="POST" action="{ url 'facturation:enregistrer' projet.id}">
            {% csrf_token %}
            {% for facture in factures_formset %}
                <div class='form-row'>
                    {{facture | crispy}}
                    <button class='btn btn-outline-danger remove-form-row m2'><i class="fas fa-trash"></i></button>
                </div>
            {% endfor %}
            <button type='submit' class='btn btn-outline-primary'><i class="fas fa-save"></i> Enregistrer la facturation</button>
            </br>
            <small class='text-muted'>Merci de ne pas laisser de facture vide.</small>
        </form>
    </div>
</div>
<div class='row mt-5'>
    <div class='col-12 text-center card border-grey border-left-0 border-right-0'>
        <h2>Chiffre d'affaire</h2>
    </div>
</div>

<script src="{% static 'assets/js/projets_script/gestion_commandes.js' %}" type='text/javascript'></script>
<script src="{% static 'assets/js/projets_script/gestion_factures.js' %}" type='text/javascript'></script>
{% endblock %}